#!/usr/bin/env python
#
# -*- coding: utf-8 -*-
#
# $Revision: 0.4.1 $
# $Date: Sun Feb 12 22:47:25 2006 $
# $Author: Gatis Tomsons $

import os,sys,re,threading,tempfile,codecs
from os import popen,remove
from main_win import main_win

from qt import *
from kdecore import KApplication,KIconLoader, KIcon
from kdeui import KMainWindow

	
	
class GTPY_ImageResizer(main_win):
	def __init__(self,parent = None,name = None,modal = 0,fl = 0):
		main_win.__init__(self,parent)
		self._connectSlots()
		self.setName("Form1")
		self.directory	= ''
		self.watermark	= ''
		self.border_c	= self.shadow_c = self.text_c = (0,0,0)
		self.command	= {}
		self.wm_image	= 0
			
		# set icons
		self.icons = KIconLoader()
		self.pushButton10.setIconSet(self.icons.loadIconSet('fileopen',KIcon.Small))
		self.pushButton4.setIconSet(self.icons.loadIconSet('fileopen',KIcon.Small))
		self.pushButton9.setIconSet(self.icons.loadIconSet('fileopen',KIcon.Small))
		self.pushButton3.setIconSet(self.icons.loadIconSet('ok',KIcon.Small))
		self.pushButton7.setIconSet(self.icons.loadIconSet('emptytrash',KIcon.Small))
		self.pushButton2.setIconSet(self.icons.loadIconSet('remove',KIcon.Small))
		self.pushButton1.setIconSet(self.icons.loadIconSet('add',KIcon.Small))
		
		#load fonts
		f = False
		self.comboBox6.insertItem('')
		for line in popen('convert -list type').readlines():
			if f is True:
				self.comboBox6.insertItem(line[0:line.find(' ')])
			if line[0:1] == '-':
				f = True
				
	def _connectSlots(self):
		
		self.connect(self.lineEdit1,SIGNAL("textChanged(const QString&)"),self.lineEdit1_textChanged)
		self.connect(self.lineEdit2,SIGNAL("textChanged(const QString&)"),self.lineEdit2_textChanged)
		
		self.connect(self.pushButton1,SIGNAL("released()"),self.pushButton1_released)
		self.connect(self.pushButton2,SIGNAL("released()"),self.pushButton2_released)
		self.connect(self.pushButton3,SIGNAL("released()"),self.pushButton3_released)
		self.connect(self.pushButton4,SIGNAL("released()"),self.pushButton4_released)
		self.connect(self.pushButton6,SIGNAL("released()"),self.pushButton6_released)				
		self.connect(self.pushButton7,SIGNAL("released()"),self.pushButton7_released)
		self.connect(self.pushButton8,SIGNAL("released()"),self.pushButton8_released)
		self.connect(self.pushButton9,SIGNAL("released()"),self.pushButton9_released)
		self.connect(self.pushButton10,SIGNAL("released()"),self.pushButton10_released)
		self.connect(self.pushButton11,SIGNAL("released()"),self.pushButton11_released)
				
	def pushButton1_released(self):
		flist = QFileDialog.getOpenFileNames("Images (*.png *.jpg *.gif *.PNG *.JPG *.GIF)", os.environ['HOME'], self)
		if len(flist) > 0:
			for f in flist:
				info = QFileInfo(QFile(f))
				if info.exists():
					item = QListViewItem(self.listView1)
					item.setText(0,info.fileName())
					item.setText(1,info.extension().lower())
					item.setText(2,str(info.size()))
					item.setText(3,info.dirPath())
					if self.directory == '':
						self.directory = str(info.dirPath())
						self.lineEdit3.setText(info.dirPath())
					elif self.directory != '' and info.dirPath() != self.directory:
						self.directory = ''
						self.lineEdit3.setText('')
					
	def pushButton2_released(self):
		if self.listView1.childCount() > 0:
			item = self.listView1.firstChild()
			while item:
				next = item.nextSibling()
				if self.listView1.isSelected(item):
					self.listView1.takeItem(item)
				item = next
		
	def pushButton7_released(self):
		if self.listView1.childCount() > 0:
			self.listView1.clear()
			
	def pushButton3_released(self):
		text 	= str(self.lineEdit1.text())
		text2 	= str(self.lineEdit2.text())
		if self.listView1.childCount() > 0 and text.isdigit() and (re.match('^[A-Za-z0-9_\.]+$',text2) is not None or text2 == '') and self.directory != '':
			self.all_enable(False)
			act = threading.Thread(target = self.do_action)
			act.start()

	def lineEdit1_textChanged(self,a0):
		text = str(a0)
		if not text.isdigit():
			pal = QPalette(self.lineEdit1.palette())
			pal.setColor(QColorGroup.Base, QColor(255,227,227))
			pal.setColor(QColorGroup.Background, QColor(255,227,227))
			self.lineEdit1.setPalette(pal)
			self.lineEdit1.update()
 		else:
			self.lineEdit1.unsetPalette()
			self.lineEdit1.update()
			
	def lineEdit2_textChanged(self,a0):
		text = str(a0)
		if re.match('^[A-Za-z0-9_\.]+$',text) is None and text != '':
			pal = QPalette(self.lineEdit2.palette())
			pal.setColor(QColorGroup.Base, QColor(255,227,227))
			pal.setColor(QColorGroup.Background, QColor(255,227,227))
			self.lineEdit2.setPalette(pal)
			self.lineEdit2.update()
 		else:
			self.lineEdit2.unsetPalette()
			self.lineEdit2.update()

	def pushButton4_released(self):
		directory = str(QFileDialog.getExistingDirectory(os.environ['HOME'], self, 'Get existing directory', 'Chose a directory',True))
		if os.access(directory,os.X_OK) and os.access(directory,os.W_OK):
			directory = directory[:len(directory)-1]
			self.lineEdit3.setText(directory)
			self.directory = directory

	def do_action(self):
		pixels 	= str(self.lineEdit1.text())
		prefix	= str(self.lineEdit2.text())
		quality_str = ''
		#---------------------------------->
		
		# size
		if str(self.comboBox1.currentText()) == 'Width':
			resize_str = '-thumbnail "%sx"' % (pixels,)
		else:
			resize_str = '-thumbnail "x%s"' % (pixels,)
		quality 	= str(self.comboBox2.currentText())
		
		#border
		if self.spinBox1.value() > 0:
			border	= '-bordercolor "%s" -border %s' % ('rgb'+str(self.border_c),str(self.spinBox1.value()))
		else:
			border = ''
			
		# quality
		if quality != '100':
			setQuality = True
		else:
			setQuality = False
				
		# monochrome
		if self.checkBox5.isChecked():
			monochrome = '-monochrome'
		else:
			monochrome = ''
		
		# black & white
		if self.checkBox4.isChecked():
			black_white = '-colorspace Gray'
		else:
			black_white = ''
					
		# blur
		if self.spinBox2.value() > 0:
			blur = '-blur 0x%s' % (str(self.spinBox2.value()),)
		else:
			blur = ''
		
		# wattermark text
		if self.lineEdit5.text() and self.comboBox6.currentText():
			tmp_file = tempfile.mktemp()
			tmp_F = codecs.open(filename=tmp_file,mode='w+',encoding='utf-8')
			tmp_F.write(str(self.lineEdit5.text().utf8()).decode('utf-8'))
			tmp_F.close()
			watermark_text = '-fill "%s" -gravity %s -font %s -annotate +20+20 \'@%s\'' % ('rgb'+str(self.text_c),str(self.comboBox4.currentText()),str(self.comboBox6.currentText()),str(tmp_file))
		else:
			tmp_file = ''
			watermark_text = ''
				
		# wattermark image
		if self.watermark:
			watermark_image = 'composite -dissolve %s -gravity %s -geometry +%s+%s "%s"' % (str(100 - int(self.spinBox9.value()))+'%',str(self.comboBox3.currentText()),str(self.spinBox11.value()),str(self.spinBox10.value()),self.watermark)
		else:
			watermark_image = ''
		#---------------------------------->
		
		self.progressBar1.setProgress(0)
		count_items = self.listView1.childCount()
		self.progressBar1.setTotalSteps(count_items)
		item = self.listView1.firstChild()
		while item:
			if item.text(1) == 'jpg':
				if setQuality:
					quality_str = '-quality %s ' % (quality,)
				b_col = 'white'
			else:
				quality_str = ''
				b_col = 'none'
			
			if self.spinBox3.value() > 0:
					im = QImage(str(item.text(3))+'/'+str(item.text(0)))
					X = self.spinBox5.value()
					Y = self.spinBox6.value()
					if X > 0: X = '+'+str(X)
					if Y > 0: Y = '+'+str(Y)
					
					shadow	= '\( +clone -background "%s" -shadow %sx%s%s%s \) +swap -background "%s" -mosaic' % ('rgb'+str(self.shadow_c),str(self.spinBox3.value()),str(self.spinBox4.value()),X,Y,b_col)
			else:
				shadow	= ''
				
			dest_img = self.directory + '/' + prefix + str(item.text(0))
			command = 'convert "%s" %s %s %s %s %s %s %s %s "%s"' % (
															str(item.text(3))+'/'+str(item.text(0)),
															resize_str,															
															border,
															shadow,
															monochrome,
															blur,
															black_white,															
															quality_str,
															watermark_text,
															dest_img)
			# for debug
			print command
			popen(command).read()
						
			# watermark
			command = watermark_image+' "'+dest_img+'"'+' "'+dest_img+'"'
			print command
			popen(command).read()
			
			self.progressBar1.setProgress(self.progressBar1.progress() + 1)
			item = item.nextSibling()
		if tmp_file:
			remove(tmp_file)
		self.listView1.clear()
		self.progressBar1.reset()
		self.all_enable(True)

	def all_enable(self,act=True):
		self.pushButton1.setEnabled(act)
		self.pushButton2.setEnabled(act)
		self.pushButton3.setEnabled(act)
		self.pushButton7.setEnabled(act)
		self.pushButton9.setEnabled(act)
		self.listView1.setEnabled(act)
		self.tabWidget2.setEnabled(act)
	
	def pushButton6_released(self):
		color = QColorDialog.getColor(QColor(),self)
		if color:
			self.border_c =	color.getRgb()
			self.pushButton6.setPaletteBackgroundColor(color)
								
	def pushButton8_released(self):
		color = QColorDialog.getColor(QColor(),self)
		if color:
			self.shadow_c =	color.getRgb()
			self.pushButton8.setPaletteBackgroundColor(color)
			
	def pushButton9_released(self):
		directory = str(QFileDialog.getExistingDirectory(os.environ['HOME'], self, 'Get existing directory', 'Choose a directory',True))
		if directory:
			if os.access(directory,os.X_OK) and os.access(directory,os.W_OK):
				for item in os.listdir(directory):
					f = directory+'/'+item
					info = QFileInfo(QFile(f))
					if info.exists() and info.extension().lower() in ['jpg','jpeg','gif','png']:
						item = QListViewItem(self.listView1)
						item.setText(0,info.fileName())
						item.setText(1,info.extension().lower())
						item.setText(2,str(info.size()))
						item.setText(3,info.dirPath())
						if self.directory == '':
							self.directory = str(info.dirPath())
							self.lineEdit3.setText(info.dirPath())
						elif self.directory != '' and info.dirPath() != self.directory:
							self.directory = ''
							self.lineEdit3.setText('')
														
	def pushButton10_released(self):
		if self.wm_image == 0:
			f = QFileDialog.getOpenFileName(os.environ['HOME'],"Images (*.png *.jpg *.gif *.PNG *.JPG *.GIF)", self,'Get existing file', 'Choose an image')
			if f:
				f = str(f)
				if os.access(f,os.R_OK):
					self.watermark = f
					self.lineEdit4.setText(f)
					self.wm_image = 1
					self.pushButton10.setIconSet(self.icons.loadIconSet('clear_left',KIcon.Small))
		else:
			self.lineEdit4.setText('')
			self.watermark = ''
			self.wm_image = 0
			self.pushButton10.setIconSet(self.icons.loadIconSet('fileopen',KIcon.Small))				
		
	def pushButton11_released(self):
		color = QColorDialog.getColor(QColor(),self)
		if color:
			self.text_c = color.getRgb()
			self.pushButton11.setPaletteBackgroundColor(color)
					
class main_loop(KApplication):
		def __init__(self,args):
			app = KApplication(args, 'GTPY_ImageResizer')
			app.connect(app, SIGNAL("lastWindowClosed()"),app, SLOT("quit()"))
			mainWindow = GTPY_ImageResizer(None, 'GTPY_ImageResizer')
			app.setMainWidget(mainWindow)
			mainWindow.show()
			app.exec_loop()		

if __name__ == '__main__':
	main_loop(sys.argv)